// pages/caseHistory/caseHistory.js
const app = getApp();
Page({

	/**
	 * 页面的初始数据
	 */
	data: {
		token: '',
		list: [],
		triggered: false,
		page: {
			page: 1,
			rows: 10
		},
		scrollHeight: 400,
		totalNum: 0,
	},

	/**
	 * 生命周期函数--监听页面加载
	 */
	onLoad(options) {
		var _self = this;
		wx.getStorage({
			key: 'token',
			success: function (res) {
				_self.setData({
					token: res.data
				})
				_self.getCaseList();
			}
		})
		let screenHeight = wx.getSystemInfoSync().windowHeight;
		this.setData({
			scrollHeight: screenHeight
		})
	},


	//获取列表
	getCaseList() {
		var _self = this;
		wx.showLoading({
			title: '加载中...',
		})
		app.restAjax.get(app.restAjax.path('{reqesutUrl}app/reportcase/listreportcaseofmine', [app.requestUrl]), _self.data.page, {
			headers: {
				token: _self.data.token
			}
		}, function (code, data) {
			wx.hideLoading();
			console.log(data);
			_self.setData({
				totalNum: data.total
			})
			if (data.rows.length == 0) {
				if (_self.data.page.page == 1) {
					_self.setData({
						list: []
					})
				} else {
					_self.setData({
						[`page.page`]: _self.data.page.page - 1
					})
					wx.showToast({
						title: '暂无更多数据',
						icon: 'none'
					})
					return false;
				}
			}
			if (_self.data.page.page == 1) {
				_self.setData({
					list: data.rows
				})
			} else {
				_self.setData({
					list: _self.data.list.concat(data.rows)
				})
			}
		});
	},
	onScrollRefresh() {
		console.log('加载中...')
		var _self = this;
		_self.setData({
			list: [],
			['page.page']: 1,
			triggered: false,
			totalNum: 0

		})
		_self.getCaseList()
	},
	//加载更多
	onLoadMore() {
		console.log(this.data.list.length + "==" + this.data.totalNum)
		var self = this
		if (self.data.totalNum === self.data.list.length) {
			wx.showToast({
				title: '暂无更多数据',
				icon: 'none'
			})
		} else {
			var pageNum = 'page.page'
			self.setData({
				[pageNum]: self.data.page.page + 1
			})
			this.getCaseList()
		}
	},
	//详情
	goDetail(e) {
		var _self = this;
		var id = e.currentTarget.dataset.id;
		var status = e.currentTarget.dataset.status;
		if ('4' == status) {
			//待检查
			wx.navigateTo({
				url: '/pages/caseCheck/caseCheck?id=' + id,
				events: {
					doNeedRefresh(data) {
						_self.onScrollRefresh();
					}
				}
			})
		} else {
			//详情
			wx.navigateTo({
				url: '/pages/caseDetail/caseDetail?id=' + id,
			})
		}
	}
})